(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/forms'), require('fast-equals'), require('@angular/common'), require('@angular/core'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ngrx-clean-forms', ['exports', '@angular/forms', 'fast-equals', '@angular/common', '@angular/core', 'rxjs', 'rxjs/operators'], factory) :
    (global = global || self, factory(global['ngrx-clean-forms'] = {}, global.ng.forms, global.fastEquals, global.ng.common, global.ng.core, global.rxjs, global.rxjs.operators));
}(this, (function (exports, forms, fastEquals, common, core, rxjs, operators) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Maps an object of control states to a value given by the `mapFunc`.
     *
     * \@example
     * // Mapping of:
     * const controls = {
     *  firstControl: {
     *    value: 'firstValue',
     *    ...
     *  },
     *  secondControl: {
     *    value: 'secondValue',
     *    ...
     *  },
     * }
     *
     * // With the function:
     * const mapFunc = (control) => control.value
     *
     * // Will result in:
     * const result = {
     *  firstControl: 'firstValue',
     *  secondControl: 'secondValue'
     * }
     * @template TControls, R
     * @param {?} controls Object which contains keys and associated control update.
     * @param {?} mapFunc Mapper function to convert the update.
     *
     * @return {?}
     */
    function mapFormGroupControlStates(controls, mapFunc) {
        return mapFormControls(controls, mapFunc);
    }
    /**
     * Maps an object of control summaries to a value given by the `mapFunc`.
     *
     * \@example
     * // Mapping of:
     * const controls = {
     *  firstControl: {
     *    value: 'firstValue',
     *    ...
     *  },
     *  secondControl: {
     *    value: 'secondValue',
     *    ...
     *  },
     * }
     *
     * // With the function:
     * const mapFunc = (control) => control.value
     *
     * // Will result in:
     * const result = {
     *  firstControl: 'firstValue',
     *  secondControl: 'secondValue'
     * }
     * @template TControls, R
     * @param {?} controls Object which contains keys and associated control summaries.
     * @param {?} mapFunc Mapper function to convert the update.
     *
     * @return {?}
     */
    function mapFormGroupControlSummaries(controls, mapFunc) {
        return mapFormControls(controls, mapFunc);
    }
    /**
     * Maps an object of control updates to a value given by the `mapFunc`.
     *
     * \@example
     * // Mapping of:
     * const controls = {
     *  firstControl: {
     *    value: 'firstValue',
     *    ...
     *  },
     *  secondControl: {
     *    value: 'secondValue',
     *    ...
     *  },
     * }
     *
     * // With the function:
     * const mapFunc = (control) => control.value
     *
     * // Will result in:
     * const result = {
     *  firstControl: 'firstValue',
     *  secondControl: 'secondValue'
     * }
     * @template TControls, R
     * @param {?} controls Object which contains keys and associated control updates.
     * @param {?} mapFunc Mapper function to convert the update.
     *
     * @return {?}
     */
    function mapFormGroupControlUpdates(controls, mapFunc) {
        return mapFormControls(controls, mapFunc);
    }
    /**
     * @template TControls, R
     * @param {?} controls
     * @param {?} mapFunc
     * @return {?}
     */
    function mapFormControls(controls, mapFunc) {
        /** @type {?} */
        var result = Object.entries(controls)
            .map((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var _b;
            var _c = __read(_a, 2), key = _c[0], control = _c[1];
            return (_b = {},
                _b[key] = mapFunc(control, key),
                _b);
        }))
            .reduce((/**
         * @param {?} ctrl1
         * @param {?} ctrl2
         * @return {?}
         */
        function (ctrl1, ctrl2) { return (__assign({}, ctrl1, ctrl2)); }), {});
        return (/** @type {?} */ (result));
    }
    /**
     * Converts one or multiple Angular validators for the usage with this framework.
     * Does **not** support asynchronous validators.
     * Uses Validators.compose from \@angular/forms.
     *
     * Only a subset of properties is available for the Angular validators:
     * `value, dirty, pristine, touched, untouched, enabled, disabled`
     * @template T
     * @param {...?} fn Angular validator function..
     * @return {?}
     */
    function validatorOf() {
        var fn = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            fn[_i] = arguments[_i];
        }
        /** @type {?} */
        var composed = forms.Validators.compose(fn);
        return (/**
         * @param {?} control
         * @return {?}
         */
        function (control) {
            return composed((/** @type {?} */ ({
                value: control.value,
                dirty: !control.pristine,
                pristine: control.pristine,
                touched: !control.untouched,
                untouched: control.untouched,
                enabled: !control.disabled,
                disabled: control.disabled,
            })));
        });
    }
    /**
     * Merges an array of `FormControlErrors`.
     * Returns null if all errors are null.
     * @param {...?} errors An array of `FormControlErrors` which will be merged into a single `FormControlErrors` value.
     * @return {?}
     */
    function mergeFormControlErrors() {
        var errors = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            errors[_i] = arguments[_i];
        }
        return errors.reduce((/**
         * @param {?} e1
         * @param {?} e2
         * @return {?}
         */
        function (e1, e2) {
            if (!e1 && !e2) {
                return null;
            }
            if (!e1) {
                return e2;
            }
            if (!e2) {
                return e1;
            }
            return __assign({}, e1, e2);
        }), null);
    }
    /**
     * Merges an array of errors.
     * The different child control errors will also be merged.
     * Returns null if all errors are null.
     * \@example
     * // Merge of:
     * {
     *   stringControl: {
     *     firstError: 'firstError'
     *   }
     * },
     * {
     *   stringControl: {
     *     secondError: 'secondError'
     *   }
     * }
     *
     * // Will result in:
     * {
     *   stringControl: {
     *     firstError: 'firstError',
     *     secondError: 'secondError'
     *   }
     * }
     *
     * @template TControls
     * @param {...?} errors Multiple errors to be merged.
     *
     * @return {?}
     */
    function mergeFormGroupErrors() {
        var errors = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            errors[_i] = arguments[_i];
        }
        return errors.reduce((/**
         * @param {?} group1
         * @param {?} group2
         * @return {?}
         */
        function (group1, group2) {
            if (!group1 && !group2) {
                return null;
            }
            if (!group1) {
                return group2;
            }
            if (!group2) {
                return group1;
            }
            return __assign({}, group1, group2, Object.keys(group1)
                .filter((/**
             * @param {?} key1
             * @return {?}
             */
            function (key1) { return Object.keys(group2).find((/**
             * @param {?} key2
             * @return {?}
             */
            function (key2) { return key1 === key2; })); }))
                .map((/**
             * @param {?} key
             * @return {?}
             */
            function (key) {
                var _a;
                return (_a = {},
                    _a[key] = mergeFormControlErrors(group1[key], group2[key]),
                    _a);
            }))
                .reduce((/**
             * @param {?} e1
             * @param {?} e2
             * @return {?}
             */
            function (e1, e2) { return (__assign({}, e1, e2)); }), {}));
        }), null);
    }
    /**
     * Merges an array of errors.
     * Errors at each index will also be merged.
     * Returns null if all errors are null.
     * \@example
     * // Merge of:
     * [
     *   {
     *     firstError: 'firstError'
     *   }
     * ],
     * [
     *   stringControl: {
     *     secondError: 'secondError'
     *   }
     * ]
     *
     * // Will result in:
     * [
     *   {
     *     firstError: 'firstError',
     *     secondError: 'secondError'
     *   }
     * ]
     *
     * @param {...?} errors Multiple errors to be merged.
     *
     * @return {?}
     */
    function mergeFormArrayErrors() {
        var errors = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            errors[_i] = arguments[_i];
        }
        /** @type {?} */
        var mergedErrors = errors
            .filter(Boolean)
            .reduce((/**
         * @param {?} arr1
         * @param {?} arr2
         * @return {?}
         */
        function (arr1, arr2) { return (arr1.length >= arr2.length ? arr1 : arr2); }), [])
            .map((/**
         * @param {?} _
         * @param {?} i
         * @return {?}
         */
        function (_, i) { return mergeFormControlErrors.apply(void 0, __spread(errors.map((/**
         * @param {?} arrayErrors
         * @return {?}
         */
        function (arrayErrors) { return arrayErrors[i]; })))); }));
        return mergedErrors.filter(Boolean).length > 0 ? mergedErrors : null;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Returns a `FormControlState` which represents the input state with the applied update.
     * The returned value is a new constructed object, except when the update is invalid.
     *
     * @template T
     * @param {?} control The `FormControlState` which the update will be applied to.
     * @param {?} update The `FormControlUpdate` itself.
     * @return {?}
     */
    function reduceFormControl(control, update) {
        if (!update) {
            return control;
        }
        return __assign({}, control, update);
    }
    /**
     * Returns a `FormGroupState` which represents the input state with the applied update.
     * The returned value is a new constructed object, except when the update is invalid.
     *
     * @template TControls
     * @param {?} group
     * @param {?} update The `FormGroupUpdate` itself.
     * @return {?}
     */
    function reduceFormGroup(group, update) {
        if (!update) {
            return group;
        }
        return __assign({}, group, update, { controls: __assign({}, group.controls, (update.controls
                ? mapFormGroupControlUpdates(update.controls, (/**
                 * @param {?} control
                 * @param {?} key
                 * @return {?}
                 */
                function (control, key) { return (__assign({}, group.controls[key], control)); }))
                : {})) });
    }
    /**
     * Returns a `FormArrayState` which represents the input state with the applied update.
     * The returned value is a new constructed object, except when the update is invalid.
     *
     * @template T
     * @param {?} group
     * @param {?} update The `FormArrayUpdate` itself. Invalid values and empty objects inside the `update.controls` array will be ignored.
     * @return {?}
     */
    function reduceFormArray(group, update) {
        if (!update) {
            return group;
        }
        return __assign({}, group, update, { controls: group.controls.map((/**
             * @param {?} control
             * @param {?} index
             * @return {?}
             */
            function (control, index) {
                return update && update.controls ? reduceFormControl(control, update.controls[index]) : control;
            })) });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Initializes a new `FormControlState`.
     * @see `FormControlInit`
     *
     * \@example
     * initFormControl(['value', [validator]])
     * initFormControl({value: 'value', validators: [validator], disabled: true, ...})
     * @template T
     * @param {?} initial
     * @return {?}
     */
    function initFormControl(initial) {
        return Array.isArray(initial)
            ? initFormControlFromTuple(initial)
            : initFormControlFromUpdate(initial);
    }
    /**
     * Initializes a new `FormGroupState`.
     * @see `FormGroupInit`
     *
     * \@example
     * initFormGroup({
     *  firstControl: ['firstValue', [validator]],
     *  secondControl: {value: 'value', validators: [validator], disabled: true, ...}
     * })
     * @template TControls
     * @param {?} controls An object containing control initializations.
     * @return {?}
     */
    function initFormGroup(controls) {
        return {
            controls: (/** @type {?} */ (Object.entries(controls)
                .map((/**
             * @param {?} __0
             * @return {?}
             */
            function (_a) {
                var _b;
                var _c = __read(_a, 2), key = _c[0], initial = _c[1];
                return (_b = {},
                    _b[key] = initFormControl(initial),
                    _b);
            }))
                .reduce((/**
             * @param {?} ctrl1
             * @param {?} ctrl2
             * @return {?}
             */
            function (ctrl1, ctrl2) { return (__assign({}, ctrl1, ctrl2)); }), {}))),
        };
    }
    /**
     * Initializes a new `FormArrayState`.
     * @see `FormArrayInit`
     *
     * \@example
     * initFormArray([
     *  ['firstValue', [validator]],
     *  {value: 'value', validators: [validator], disabled: true, ...}
     * ])
     * @template T
     * @param {?} initial
     * @return {?}
     */
    function initFormArray(initial) {
        return {
            controls: initial.map((/**
             * @param {?} init
             * @return {?}
             */
            function (init) { return initFormControl(init); })),
        };
    }
    /**
     * @template T
     * @param {?} __0
     * @return {?}
     */
    function initFormControlFromTuple(_a) {
        var _b = __read(_a, 3), value = _b[0], _c = _b[1], validators = _c === void 0 ? [] : _c, _d = _b[2], disabled = _d === void 0 ? false : _d;
        return initFormControlFromUpdate({ value: value, validators: validators, disabled: disabled });
    }
    /**
     * @template T
     * @param {?} initialUpdate
     * @return {?}
     */
    function initFormControlFromUpdate(initialUpdate) {
        return reduceFormControl({
            value: undefined,
            initialValue: initialUpdate.value,
            pristine: true,
            untouched: true,
            disabled: false,
            validators: [],
        }, initialUpdate);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Resets a control back to the default values.
     * The following values will be ignored and stay the same:
     * - `initialValue`
     * - `validators`
     * - `disabled`
     *
     * @template T
     * @param {?} control The `FormControlState` which should be used to create the reset.
     * @param {?=} initialValue Optional parameter for passing a new initial value.
     * @return {?}
     */
    function resetFormControl(control, initialValue) {
        if (initialValue === void 0) { initialValue = control.initialValue; }
        return initFormControl([initialValue, control.validators, control.disabled]);
    }
    /**
     * Resets a group back to its default values.
     * Internally calls `resetFormControl` for every control.
     *
     * @see `resetFormControl`
     *
     * @template TControls
     * @param {?} group The `FormGroupState` which should be used to create the reset.
     * @return {?}
     */
    function resetFormGroup(group) {
        /** @type {?} */
        var controls = mapFormGroupControlStates(group.controls, (/**
         * @param {?} control
         * @return {?}
         */
        function (control) {
            return resetFormControl(control);
        }));
        return reduceFormGroup(group, { controls: controls });
    }
    /**
     * Resets an array back to its default values.
     * Internally calls `resetFormControl` for every control.
     *
     * @see `resetFormControl`
     *
     * @template T
     * @param {?} array The `FormArrayState` which should be used to create the reset.
     * @return {?}
     */
    function resetFormArray(array) {
        /** @type {?} */
        var controls = array.controls.map((/**
         * @param {?} control
         * @return {?}
         */
        function (control) { return resetFormControl(control); }));
        return reduceFormArray(array, { controls: controls });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     * @param {?} control
     * @return {?}
     */
    function getFormControlErrors(control) {
        return control.validators.map((/**
         * @param {?} validator
         * @return {?}
         */
        function (validator) { return validator(control); }));
    }
    /**
     * @template TControls
     * @param {?} summaries
     * @return {?}
     */
    function getFormGroupErrors(summaries) {
        /** @type {?} */
        var errors = mapFormGroupControlSummaries(summaries, (/**
         * @param {?} summary
         * @return {?}
         */
        function (summary) { return summary.errors; }));
        Object.entries(errors)
            .filter((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var _b = __read(_a, 2), _ = _b[0], value = _b[1];
            return value === null;
        }))
            .forEach((/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var _b = __read(_a, 2), key = _b[0], _ = _b[1];
            return delete errors[key];
        }));
        return Object.keys(errors).length ? errors : null;
    }
    /**
     * @template T
     * @param {?} summaries
     * @return {?}
     */
    function getFormArrayErrors(summaries) {
        /** @type {?} */
        var errors = summaries.map((/**
         * @param {?} summary
         * @return {?}
         */
        function (summary) { return summary.errors; }));
        return errors.filter(Boolean).length ? errors : null;
    }
    /**
     * @template T
     * @param {?} control
     * @return {?}
     */
    function getFormControlChanged(control) {
        return !fastEquals.circularDeepEqual(control.value, control.initialValue);
    }
    /**
     * Creates a `FormControlSummary` from the given `FormControlState`.
     * It is possible to add additional errors.
     *
     * @template T
     * @param {?} control The `FormControlState` which is used to create the `FormControlSummary`.
     * @param {...?} additionalErrors An array of `FormControlErrors` which will be merged into the errors of the control.
     * @return {?}
     */
    function getFormControlSummary(control) {
        var additionalErrors = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            additionalErrors[_i - 1] = arguments[_i];
        }
        /** @type {?} */
        var errors = mergeFormControlErrors.apply(void 0, __spread(getFormControlErrors(control), additionalErrors));
        return __assign({}, control, { errors: errors, valid: errors === null, changed: getFormControlChanged(control) });
    }
    /**
     * @template TControls
     * @param {?} controls
     * @param {...?} additionalErrors
     * @return {?}
     */
    function getFormGroupControlSummaries(controls) {
        var additionalErrors = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            additionalErrors[_i - 1] = arguments[_i];
        }
        /** @type {?} */
        var additionalError = mergeFormGroupErrors.apply(void 0, __spread(additionalErrors));
        return mapFormGroupControlStates(controls, (/**
         * @param {?} control
         * @param {?} key
         * @return {?}
         */
        function (control, key) {
            return getFormControlSummary(control, additionalError ? additionalError[key] : null);
        }));
    }
    /**
     * @template T
     * @param {?} controls
     * @param {...?} additionalErrors
     * @return {?}
     */
    function getFormArrayControlSummaries(controls) {
        var additionalErrors = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            additionalErrors[_i - 1] = arguments[_i];
        }
        /** @type {?} */
        var additionalError = mergeFormArrayErrors.apply(void 0, __spread(additionalErrors));
        return controls.map((/**
         * @param {?} control
         * @param {?} i
         * @return {?}
         */
        function (control, i) {
            return getFormControlSummary(control, additionalError ? additionalError[i] : null);
        }));
    }
    /**
     * @template TControls
     * @param {?} group
     * @return {?}
     */
    function getFormGroupPristine(group) {
        return Object.values(group.controls).every((/**
         * @param {?} control
         * @return {?}
         */
        function (control) { return control.pristine; }));
    }
    /**
     * @template T
     * @param {?} array
     * @return {?}
     */
    function getFormArrayPristine(array) {
        return array.controls.every((/**
         * @param {?} control
         * @return {?}
         */
        function (control) { return control.pristine; }));
    }
    /**
     * @template TControls
     * @param {?} group
     * @return {?}
     */
    function getFormGroupUntouched(group) {
        return Object.values(group.controls).every((/**
         * @param {?} control
         * @return {?}
         */
        function (control) { return control.untouched; }));
    }
    /**
     * @template TControls
     * @param {?} controls
     * @return {?}
     */
    function getFormGroupChanged(controls) {
        return Object.values(controls).some((/**
         * @param {?} control
         * @return {?}
         */
        function (control) { return control.changed; }));
    }
    /**
     * @template T
     * @param {?} controls
     * @return {?}
     */
    function getFormArrayChanged(controls) {
        return controls.some((/**
         * @param {?} control
         * @return {?}
         */
        function (control) { return control.changed; }));
    }
    /**
     * @template T
     * @param {?} array
     * @return {?}
     */
    function getFormArrayUntouched(array) {
        return array.controls.every((/**
         * @param {?} control
         * @return {?}
         */
        function (control) { return control.untouched; }));
    }
    /**
     * @template T
     * @param {?} array
     * @return {?}
     */
    function getFormArrayKeys(array) {
        return array.controls.map((/**
         * @param {?} _
         * @param {?} i
         * @return {?}
         */
        function (_, i) { return i; }));
    }
    /**
     * Creates a `FormGroupSummary` from the given `FormGroupState`.
     * It is possible to add additional errors.
     *
     * @template TControls
     * @param {?} group The input `FormGroupState`. Used to create the `FormGroupSummary`.
     * @param {...?} additionalErrors An array of additional `FormGroupErrors`, which will be merged into the errors of the group and of each control.
     * @return {?}
     */
    function getFormGroupSummary(group) {
        var additionalErrors = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            additionalErrors[_i - 1] = arguments[_i];
        }
        /** @type {?} */
        var summaries = getFormGroupControlSummaries.apply(void 0, __spread([group.controls], additionalErrors));
        /** @type {?} */
        var errors = getFormGroupErrors(summaries);
        return {
            controls: summaries,
            pristine: getFormGroupPristine(group),
            untouched: getFormGroupUntouched(group),
            errors: errors,
            valid: errors === null,
            changed: getFormGroupChanged(summaries),
        };
    }
    /**
     * Creates a `FormArraySummary` from the given `FormArrayState`.
     * It is possible to add additional errors.
     *
     * @template T
     * @param {?} array The input `FormArrayState`. Used to create the `FormArraySummary`.
     * @param {...?} additionalErrors An array of additional `FormArrayErrors`, which will be merged into the errors of the array and of each control.
     * @return {?}
     */
    function getFormArraySummary(array) {
        var additionalErrors = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            additionalErrors[_i - 1] = arguments[_i];
        }
        /** @type {?} */
        var summaries = getFormArrayControlSummaries.apply(void 0, __spread([array.controls], additionalErrors));
        /** @type {?} */
        var errors = getFormArrayErrors(summaries);
        return {
            controls: summaries,
            keys: getFormArrayKeys(array),
            pristine: getFormArrayPristine(array),
            untouched: getFormArrayUntouched(array),
            errors: errors,
            valid: errors === null,
            changed: getFormArrayChanged(summaries),
        };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function FormControls() { }
    /**
     * Config from NgrxCleanForms.
     * For details of the different attributes view the TSDoc of specific attributes.
     * @record
     */
    function FormsConfig() { }
    if (false) {
        /**
         * Number of how many milliseconds needs to pass between individual updates of a `FormControl`.
         * There is no delay on the first update and also always an update after the delay.
         * @type {?}
         */
        FormsConfig.prototype.throttleTime;
        /**
         * Specifies whether only distinct values should be written to a `FormControl`.
         * Only applies to custom inputs added with `ControlValueAccessor`.
         * Prevents update loops and uses [fast-equals](https://www.npmjs.com/package/fast-equals) for comparison.
         * @type {?}
         */
        FormsConfig.prototype.distinctWritesOnly;
    }
    /**
     * @record
     * @template TControls
     */
    function FormGroupBase() { }
    /**
     * @record
     * @template T
     */
    function FormArrayBase() { }
    /**
     * @record
     * @template T
     */
    function FormControlUpdate() { }
    /**
     * @record
     * @template TControls
     */
    function FormGroupUpdate() { }
    if (false) {
        /** @type {?|undefined} */
        FormGroupUpdate.prototype.controls;
    }
    /**
     * @record
     * @template T
     */
    function FormArrayUpdate() { }
    if (false) {
        /** @type {?|undefined} */
        FormArrayUpdate.prototype.controls;
    }
    /**
     * Explicit type to create a new FormControl.
     *
     * Identical to FormControlUpdate, except for `value` which is a required attribute here.
     * @record
     * @template T
     */
    function FormControlInitUpdate() { }
    if (false) {
        /**
         * Initial value of the control.
         * @type {?}
         */
        FormControlInitUpdate.prototype.value;
    }
    /**
     * @record
     */
    function FormControlErrors() { }
    /**
     * Represents the state of a single FormControl.
     * @record
     * @template T
     */
    function FormControlState() { }
    if (false) {
        /**
         * The value of this control.
         * @type {?}
         */
        FormControlState.prototype.value;
        /**
         * The initial value of this control.
         * @type {?}
         */
        FormControlState.prototype.initialValue;
        /**
         * Indicates whether the value was not yet changed.
         * @type {?}
         */
        FormControlState.prototype.pristine;
        /**
         * Indicates whether the FormControl was not yet visited.
         * @type {?}
         */
        FormControlState.prototype.untouched;
        /**
         * Indicates whether the FormControl is disabled.
         * @type {?}
         */
        FormControlState.prototype.disabled;
        /**
         * Validators which will be used to calculate the errors.
         * Mainly used inside the summary creation.
         * @type {?}
         */
        FormControlState.prototype.validators;
    }
    /**
     * A FormGroup can contain multiple FormControls of different types, associated to a key.
     * @record
     * @template TControls
     */
    function FormGroupState() { }
    if (false) {
        /**
         * An object containing all controls of this group.
         * @type {?}
         */
        FormGroupState.prototype.controls;
    }
    /**
     * A FormArray can contain any number of FormControls.
     * @record
     * @template T
     */
    function FormArrayState() { }
    if (false) {
        /**
         * An array of all controls contained by this form.
         * @type {?}
         */
        FormArrayState.prototype.controls;
    }
    /**
     * A summary of a `FormControlState`. Contains additional information.
     * @record
     * @template T
     */
    function FormControlSummary() { }
    if (false) {
        /**
         * An object containing all errors.
         *
         * Null if no errors were found.
         * @type {?}
         */
        FormControlSummary.prototype.errors;
        /**
         * Whether the FormControl has any errors.
         * @type {?}
         */
        FormControlSummary.prototype.valid;
        /**
         * Whether the value is the same as the intial set value.
         * Uses the `intialValue` property of the `FormControlState`.
         *
         * @see `FormControlState`
         * @type {?}
         */
        FormControlSummary.prototype.changed;
    }
    /**
     * A summary of a `FormGroupState`. Contains additional information.
     * @record
     * @template TControls
     */
    function FormGroupSummary() { }
    if (false) {
        /**
         * An object containing summaries of all controls.
         * @type {?}
         */
        FormGroupSummary.prototype.controls;
        /**
         * An object containing all errors. The used keys are the same as for the controls.
         *
         * If no error is found this value is null.
         * @type {?}
         */
        FormGroupSummary.prototype.errors;
        /**
         * Indicates whether all of the FormControlSummaries inside this group are valid.
         * @type {?}
         */
        FormGroupSummary.prototype.valid;
        /**
         * Indicates whether all of the values inside this group were not yet changed.
         * @type {?}
         */
        FormGroupSummary.prototype.pristine;
        /**
         * Indicates whether all FormControls inside this group were not yet visited.
         * @type {?}
         */
        FormGroupSummary.prototype.untouched;
        /**
         * Indicates whether any of the FormControls was changed.
         * Comparison is always with the intial property of the FormControl.
         *
         * @see `FormControl`
         * @type {?}
         */
        FormGroupSummary.prototype.changed;
    }
    /**
     * A summary of a `FormArrayState`. Contains additional information.
     * @record
     * @template T
     */
    function FormArraySummary() { }
    if (false) {
        /** @type {?} */
        FormArraySummary.prototype.controls;
        /**
         * A convenience number array which contains the keys of the controls.
         *
         * For a array with the length of 2 this would be: `[0, 1]`
         * @type {?}
         */
        FormArraySummary.prototype.keys;
        /**
         * An array containing all
         * @type {?}
         */
        FormArraySummary.prototype.errors;
        /**
         * Indicates whether all of the FormControlSummaries inside this array are valid.
         * @type {?}
         */
        FormArraySummary.prototype.valid;
        /**
         * Indicates whether all of the values inside this array were not yet changed.
         * @type {?}
         */
        FormArraySummary.prototype.pristine;
        /**
         * Indicates whether all FormControls inside this array were not yet visited.
         * @type {?}
         */
        FormArraySummary.prototype.untouched;
        /**
         * Indicates whether any of the FormControls was changed.
         * Comparison is always with the intial property of the FormControl.
         *
         * @see `FormControl`
         * @type {?}
         */
        FormArraySummary.prototype.changed;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var CONFIG_TOKEN = new core.InjectionToken('NGRX_CLEAN_FORMS_CONFIG');
    /** @type {?} */
    var defaultConfig = {
        throttleTime: 20,
        distinctWritesOnly: true,
    };
    /** @type {?} */
    var throttle = (/**
     * @param {?} config
     * @return {?}
     */
    function (config) {
        return operators.throttleTime(config.throttleTime, rxjs.asyncScheduler, {
            leading: true,
            trailing: true,
        });
    });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var cssClasses = {
        invalid: 'ng-invalid',
        valid: 'ng-valid',
        pristine: 'ng-pristine',
        dirty: 'ng-dirty',
        touched: 'ng-touched',
        untouched: 'ng-untouched',
        changed: 'ng-changed',
        initial: 'ng-initial',
    };
    /** @type {?} */
    var CONTROL_DIRECTIVE_SELECTOR = "ngrxFormControl";
    /**
     * @abstract
     * @template T
     */
    var AbstractControlDirective = /** @class */ (function () {
        function AbstractControlDirective(ref, r2, injectedConfig) {
            var _this = this;
            this.ref = ref;
            this.r2 = r2;
            this.injectedConfig = injectedConfig;
            this.controlUpdate = new core.EventEmitter(true);
            this.touched$ = new rxjs.Subject();
            this.value$ = new rxjs.Subject();
            this.config$ = new rxjs.BehaviorSubject(this.injectedConfig);
            this.summarySubscription = new rxjs.Subscription();
            this.config$
                .pipe(operators.switchMap((/**
             * @param {?} config
             * @return {?}
             */
            function (config) {
                return rxjs.merge(_this.touched$.pipe(throttle(config)), _this.value$.pipe(throttle(config)));
            })))
                .subscribe((/**
             * @param {?} value
             * @return {?}
             */
            function (value) { return _this.controlUpdate.emit(value); }));
        }
        Object.defineProperty(AbstractControlDirective.prototype, "setControlSummary", {
            set: /**
             * @param {?} controlSummary
             * @return {?}
             */
            function (controlSummary) {
                if (!controlSummary) {
                    return;
                }
                this.updateSummary(controlSummary);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractControlDirective.prototype, "setConfig", {
            set: /**
             * @param {?} inputConfig
             * @return {?}
             */
            function (inputConfig) {
                /** @type {?} */
                var config = __assign({}, this.injectedConfig, inputConfig);
                this.config$.next(config);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        AbstractControlDirective.prototype.emitTouched = /**
         * @return {?}
         */
        function () {
            this.touched$.next({ untouched: false });
        };
        /**
         * @param {?} value
         * @return {?}
         */
        AbstractControlDirective.prototype.emitValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.value$.next({ value: value, pristine: false });
        };
        /**
         * @param {?} summary
         * @return {?}
         */
        AbstractControlDirective.prototype.updateSummary = /**
         * @param {?} summary
         * @return {?}
         */
        function (summary) {
            this.setValue(summary.value);
            this.setDisabled(summary.disabled);
            this.chooseClass(cssClasses.invalid, cssClasses.valid, summary.valid);
            this.chooseClass(cssClasses.dirty, cssClasses.pristine, summary.pristine);
            this.chooseClass(cssClasses.touched, cssClasses.untouched, summary.untouched);
            this.chooseClass(cssClasses.initial, cssClasses.changed, summary.changed);
        };
        /**
         * @param {?} class1
         * @param {?} class2
         * @param {?} chooseSecond
         * @return {?}
         */
        AbstractControlDirective.prototype.chooseClass = /**
         * @param {?} class1
         * @param {?} class2
         * @param {?} chooseSecond
         * @return {?}
         */
        function (class1, class2, chooseSecond) {
            if (chooseSecond) {
                this.r2.addClass(this.ref.nativeElement, class2);
                this.r2.removeClass(this.ref.nativeElement, class1);
            }
            else {
                this.r2.addClass(this.ref.nativeElement, class1);
                this.r2.removeClass(this.ref.nativeElement, class2);
            }
        };
        /**
         * @return {?}
         */
        AbstractControlDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.summarySubscription.unsubscribe();
            this.config$.complete();
            this.touched$.complete();
            this.value$.complete();
        };
        /** @nocollapse */
        AbstractControlDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 },
            { type: undefined, decorators: [{ type: core.Inject, args: [CONFIG_TOKEN,] }] }
        ]; };
        AbstractControlDirective.propDecorators = {
            controlKey: [{ type: core.Input, args: [CONTROL_DIRECTIVE_SELECTOR,] }],
            setControlSummary: [{ type: core.Input, args: ['controlSummary',] }],
            setConfig: [{ type: core.Input, args: ['controlConfig',] }],
            controlUpdate: [{ type: core.Output }]
        };
        return AbstractControlDirective;
    }());
    if (false) {
        /** @type {?} */
        AbstractControlDirective.prototype.controlKey;
        /** @type {?} */
        AbstractControlDirective.prototype.controlUpdate;
        /**
         * @type {?}
         * @private
         */
        AbstractControlDirective.prototype.touched$;
        /**
         * @type {?}
         * @private
         */
        AbstractControlDirective.prototype.value$;
        /**
         * @type {?}
         * @protected
         */
        AbstractControlDirective.prototype.config$;
        /**
         * @type {?}
         * @private
         */
        AbstractControlDirective.prototype.summarySubscription;
        /**
         * @type {?}
         * @protected
         */
        AbstractControlDirective.prototype.ref;
        /**
         * @type {?}
         * @protected
         */
        AbstractControlDirective.prototype.r2;
        /**
         * @type {?}
         * @private
         */
        AbstractControlDirective.prototype.injectedConfig;
        /**
         * @abstract
         * @param {?} value
         * @return {?}
         */
        AbstractControlDirective.prototype.setValue = function (value) { };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RangeInputControlDirective = /** @class */ (function (_super) {
        __extends(RangeInputControlDirective, _super);
        function RangeInputControlDirective(ref, r2, config) {
            return _super.call(this, ref, r2, config) || this;
        }
        /**
         * @param {?} $event
         * @return {?}
         */
        RangeInputControlDirective.prototype.onInput = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            /** @type {?} */
            var value = ((/** @type {?} */ ($event.target))).value;
            this.emitValue(value === '' ? null : parseFloat(value));
        };
        /**
         * @return {?}
         */
        RangeInputControlDirective.prototype.onBlur = /**
         * @return {?}
         */
        function () {
            this.emitTouched();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        RangeInputControlDirective.prototype.setValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.r2.setProperty(this.ref.nativeElement, 'value', value);
        };
        /**
         * @param {?} disabled
         * @return {?}
         */
        RangeInputControlDirective.prototype.setDisabled = /**
         * @param {?} disabled
         * @return {?}
         */
        function (disabled) {
            this.r2.setProperty(this.ref.nativeElement, 'disabled', disabled);
        };
        RangeInputControlDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: "input[type=\"range\"][" + CONTROL_DIRECTIVE_SELECTOR + "]",
                    },] }
        ];
        /** @nocollapse */
        RangeInputControlDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 },
            { type: undefined, decorators: [{ type: core.Inject, args: [CONFIG_TOKEN,] }] }
        ]; };
        RangeInputControlDirective.propDecorators = {
            onInput: [{ type: core.HostListener, args: ['input', ['$event'],] }],
            onBlur: [{ type: core.HostListener, args: ['blur',] }]
        };
        return RangeInputControlDirective;
    }(AbstractControlDirective));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var RadioControlNotSupported = Error(
    // tslint:disable-next-line: max-line-length
    "Radio inputs are not yet supported. If you need to use one consider wrapping it in a Component which implements the ControlValueAccessor interface.");
    var RadioInputControlDirective = /** @class */ (function (_super) {
        __extends(RadioInputControlDirective, _super);
        function RadioInputControlDirective(ref, r2, config) {
            var _this = _super.call(this, ref, r2, config) || this;
            throw RadioControlNotSupported;
            return _this;
        }
        /**
         * @param {?} value
         * @return {?}
         */
        RadioInputControlDirective.prototype.setValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            throw RadioControlNotSupported;
        };
        RadioInputControlDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: "input[type=\"radio\"][" + CONTROL_DIRECTIVE_SELECTOR + "]",
                    },] }
        ];
        /** @nocollapse */
        RadioInputControlDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 },
            { type: undefined, decorators: [{ type: core.Inject, args: [CONFIG_TOKEN,] }] }
        ]; };
        return RadioInputControlDirective;
    }(AbstractControlDirective));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var SelectControlNotSupported = Error(
    // tslint:disable-next-line: max-line-length
    "Select inputs are not yet supported. If you need to use one consider wrapping it in a Component which implements the ControlValueAccessor interface.");
    var SelectInputControlDirective = /** @class */ (function (_super) {
        __extends(SelectInputControlDirective, _super);
        function SelectInputControlDirective(ref, r2, config) {
            var _this = _super.call(this, ref, r2, config) || this;
            throw SelectControlNotSupported;
            return _this;
        }
        /**
         * @param {?} value
         * @return {?}
         */
        SelectInputControlDirective.prototype.setValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            throw SelectControlNotSupported;
        };
        SelectInputControlDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: "select[" + CONTROL_DIRECTIVE_SELECTOR + "]",
                    },] }
        ];
        /** @nocollapse */
        SelectInputControlDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 },
            { type: undefined, decorators: [{ type: core.Inject, args: [CONFIG_TOKEN,] }] }
        ]; };
        return SelectInputControlDirective;
    }(AbstractControlDirective));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NumberInputControlDirective = /** @class */ (function (_super) {
        __extends(NumberInputControlDirective, _super);
        function NumberInputControlDirective(ref, r2, config) {
            return _super.call(this, ref, r2, config) || this;
        }
        /**
         * @param {?} $event
         * @return {?}
         */
        NumberInputControlDirective.prototype.onInput = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            /** @type {?} */
            var value = ((/** @type {?} */ ($event.target))).value;
            this.emitValue(value === '' ? null : parseFloat(value));
        };
        /**
         * @return {?}
         */
        NumberInputControlDirective.prototype.onBlur = /**
         * @return {?}
         */
        function () {
            this.emitTouched();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        NumberInputControlDirective.prototype.setValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.r2.setProperty(this.ref.nativeElement, 'value', value === null ? '' : value);
        };
        /**
         * @param {?} disabled
         * @return {?}
         */
        NumberInputControlDirective.prototype.setDisabled = /**
         * @param {?} disabled
         * @return {?}
         */
        function (disabled) {
            this.r2.setProperty(this.ref.nativeElement, 'disabled', disabled);
        };
        NumberInputControlDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: "input[type=\"number\"][" + CONTROL_DIRECTIVE_SELECTOR + "]",
                    },] }
        ];
        /** @nocollapse */
        NumberInputControlDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 },
            { type: undefined, decorators: [{ type: core.Inject, args: [CONFIG_TOKEN,] }] }
        ]; };
        NumberInputControlDirective.propDecorators = {
            onInput: [{ type: core.HostListener, args: ['input', ['$event'],] }],
            onBlur: [{ type: core.HostListener, args: ['blur',] }]
        };
        return NumberInputControlDirective;
    }(AbstractControlDirective));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TextInputControlDirective = /** @class */ (function (_super) {
        __extends(TextInputControlDirective, _super);
        function TextInputControlDirective(ref, r2, config) {
            return _super.call(this, ref, r2, config) || this;
        }
        /**
         * @param {?} $event
         * @return {?}
         */
        TextInputControlDirective.prototype.onInput = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            /** @type {?} */
            var value = ((/** @type {?} */ ($event.target))).value;
            this.emitValue(value);
        };
        /**
         * @return {?}
         */
        TextInputControlDirective.prototype.onBlur = /**
         * @return {?}
         */
        function () {
            this.emitTouched();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        TextInputControlDirective.prototype.setValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.r2.setProperty(this.ref.nativeElement, 'value', value);
        };
        /**
         * @param {?} disabled
         * @return {?}
         */
        TextInputControlDirective.prototype.setDisabled = /**
         * @param {?} disabled
         * @return {?}
         */
        function (disabled) {
            this.r2.setProperty(this.ref.nativeElement, 'disabled', disabled);
        };
        TextInputControlDirective.decorators = [
            { type: core.Directive, args: [{
                        // tslint:disable-next-line: max-line-length
                        selector: "input[type=\"text\"][" + CONTROL_DIRECTIVE_SELECTOR + "],textarea[" + CONTROL_DIRECTIVE_SELECTOR + "],input:not([type=\"checkbox\"]):not([type=\"number\"]):not([type=\"range\"]):not([type=\"radio\"])[" + CONTROL_DIRECTIVE_SELECTOR + "]",
                    },] }
        ];
        /** @nocollapse */
        TextInputControlDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 },
            { type: undefined, decorators: [{ type: core.Inject, args: [CONFIG_TOKEN,] }] }
        ]; };
        TextInputControlDirective.propDecorators = {
            onInput: [{ type: core.HostListener, args: ['input', ['$event'],] }],
            onBlur: [{ type: core.HostListener, args: ['blur',] }]
        };
        return TextInputControlDirective;
    }(AbstractControlDirective));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ValueAccessorConnectorDirective = /** @class */ (function (_super) {
        __extends(ValueAccessorConnectorDirective, _super);
        function ValueAccessorConnectorDirective(ref, r2, config, accessors) {
            var _this = _super.call(this, ref, r2, config) || this;
            _this.initAccessor(accessors);
            return _this;
        }
        /**
         * @param {?} accessors
         * @return {?}
         */
        ValueAccessorConnectorDirective.prototype.initAccessor = /**
         * @param {?} accessors
         * @return {?}
         */
        function (accessors) {
            var _this = this;
            if (!accessors || !accessors.length) {
                return;
            }
            this.accessor = accessors[0];
            this.accessor.registerOnChange((/**
             * @param {?} val
             * @return {?}
             */
            function (val) { return _super.prototype.emitValue.call(_this, val); }));
            this.accessor.registerOnTouched((/**
             * @return {?}
             */
            function () { return _super.prototype.emitTouched.call(_this); }));
        };
        /**
         * @param {?} value
         * @return {?}
         */
        ValueAccessorConnectorDirective.prototype.setValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (!this.accessor) {
                return;
            }
            if (this.config$.value.distinctWritesOnly && this.equalsLastValue(value)) {
                return;
            }
            this.accessor.writeValue(value);
        };
        /**
         * @param {?} disabled
         * @return {?}
         */
        ValueAccessorConnectorDirective.prototype.setDisabled = /**
         * @param {?} disabled
         * @return {?}
         */
        function (disabled) {
            if (this.accessor && this.accessor.setDisabledState) {
                this.accessor.setDisabledState(disabled);
            }
        };
        /**
         * @param {?} value
         * @return {?}
         */
        ValueAccessorConnectorDirective.prototype.equalsLastValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            /** @type {?} */
            var result = fastEquals.circularDeepEqual(value, this.lastValue);
            if (!result) {
                this.lastValue = value;
            }
            return result;
        };
        ValueAccessorConnectorDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: "[" + CONTROL_DIRECTIVE_SELECTOR + "]",
                    },] }
        ];
        /** @nocollapse */
        ValueAccessorConnectorDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 },
            { type: undefined, decorators: [{ type: core.Inject, args: [CONFIG_TOKEN,] }] },
            { type: Array, decorators: [{ type: core.Optional }, { type: core.Inject, args: [forms.NG_VALUE_ACCESSOR,] }] }
        ]; };
        return ValueAccessorConnectorDirective;
    }(AbstractControlDirective));
    if (false) {
        /** @type {?} */
        ValueAccessorConnectorDirective.prototype.accessor;
        /** @type {?} */
        ValueAccessorConnectorDirective.prototype.lastValue;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CheckboxInputControlDirective = /** @class */ (function (_super) {
        __extends(CheckboxInputControlDirective, _super);
        function CheckboxInputControlDirective(ref, r2, config) {
            return _super.call(this, ref, r2, config) || this;
        }
        /**
         * @param {?} $event
         * @return {?}
         */
        CheckboxInputControlDirective.prototype.onInput = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            /** @type {?} */
            var checked = ((/** @type {?} */ ($event.target))).checked;
            this.emitValue(checked);
        };
        /**
         * @return {?}
         */
        CheckboxInputControlDirective.prototype.onBlur = /**
         * @return {?}
         */
        function () {
            this.emitTouched();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        CheckboxInputControlDirective.prototype.setValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.r2.setProperty(this.ref.nativeElement, 'checked', value);
        };
        /**
         * @param {?} disabled
         * @return {?}
         */
        CheckboxInputControlDirective.prototype.setDisabled = /**
         * @param {?} disabled
         * @return {?}
         */
        function (disabled) {
            this.r2.setProperty(this.ref.nativeElement, 'disabled', disabled);
        };
        CheckboxInputControlDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: "input[type=\"checkbox\"][" + CONTROL_DIRECTIVE_SELECTOR + "]",
                    },] }
        ];
        /** @nocollapse */
        CheckboxInputControlDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 },
            { type: undefined, decorators: [{ type: core.Inject, args: [CONFIG_TOKEN,] }] }
        ]; };
        CheckboxInputControlDirective.propDecorators = {
            onInput: [{ type: core.HostListener, args: ['input', ['$event'],] }],
            onBlur: [{ type: core.HostListener, args: ['blur',] }]
        };
        return CheckboxInputControlDirective;
    }(AbstractControlDirective));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var controlDirectives = [
        TextInputControlDirective,
        CheckboxInputControlDirective,
        NumberInputControlDirective,
        RadioInputControlDirective,
        RangeInputControlDirective,
        SelectInputControlDirective,
        ValueAccessorConnectorDirective,
    ];

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var config = { descendants: true };
    /**
     * @abstract
     */
    var ControlChildren = /** @class */ (function () {
        function ControlChildren() {
        }
        /**
         * @protected
         * @return {?}
         */
        ControlChildren.prototype.getChildren = /**
         * @protected
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var queries$ = [
                this.textInputs,
                this.numberInputs,
                this.radioInputs,
                this.rangeInputs,
                this.selectInputs,
                this.customInputs,
                this.checkboxInputs,
            ]
                .filter(Boolean)
                .map((/**
             * @param {?} query
             * @return {?}
             */
            function (query) {
                return _this.convertToObservable(query);
            }));
            return rxjs.combineLatest(queries$).pipe(operators.map((/**
             * @param {?} queries
             * @return {?}
             */
            function (queries) { return queries.reduce((/**
             * @param {?} q1
             * @param {?} q2
             * @return {?}
             */
            function (q1, q2) { return __spread(q1, q2); }), []); })));
        };
        /**
         * @private
         * @param {?} query
         * @return {?}
         */
        ControlChildren.prototype.convertToObservable = /**
         * @private
         * @param {?} query
         * @return {?}
         */
        function (query) {
            return query.changes.pipe(operators.map((/**
             * @return {?}
             */
            function () { return query; })), operators.startWith(query), operators.map((/**
             * @param {?} list
             * @return {?}
             */
            function (list) { return list.toArray(); })));
        };
        ControlChildren.propDecorators = {
            textInputs: [{ type: core.ContentChildren, args: [TextInputControlDirective, config,] }],
            checkboxInputs: [{ type: core.ContentChildren, args: [CheckboxInputControlDirective, config,] }],
            numberInputs: [{ type: core.ContentChildren, args: [NumberInputControlDirective, config,] }],
            radioInputs: [{ type: core.ContentChildren, args: [RadioInputControlDirective, config,] }],
            rangeInputs: [{ type: core.ContentChildren, args: [RangeInputControlDirective, config,] }],
            selectInputs: [{ type: core.ContentChildren, args: [SelectInputControlDirective, config,] }],
            customInputs: [{ type: core.ContentChildren, args: [ValueAccessorConnectorDirective, config,] }]
        };
        return ControlChildren;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ControlChildren.prototype.textInputs;
        /**
         * @type {?}
         * @private
         */
        ControlChildren.prototype.checkboxInputs;
        /**
         * @type {?}
         * @private
         */
        ControlChildren.prototype.numberInputs;
        /**
         * @type {?}
         * @private
         */
        ControlChildren.prototype.radioInputs;
        /**
         * @type {?}
         * @private
         */
        ControlChildren.prototype.rangeInputs;
        /**
         * @type {?}
         * @private
         */
        ControlChildren.prototype.selectInputs;
        /**
         * @type {?}
         * @private
         */
        ControlChildren.prototype.customInputs;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     * @template Summary, Update
     */
    var AbstractFormDirective = /** @class */ (function (_super) {
        __extends(AbstractFormDirective, _super);
        function AbstractFormDirective() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.formUpdate = new core.EventEmitter();
            _this.formSummary$ = new rxjs.ReplaySubject(1);
            return _this;
        }
        Object.defineProperty(AbstractFormDirective.prototype, "setFormSummary", {
            set: /**
             * @param {?} summary
             * @return {?}
             */
            function (summary) {
                if (!summary) {
                    return;
                }
                this.formSummary$.next(summary);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        AbstractFormDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var children$ = this.getChildren();
            children$
                .pipe(operators.map((/**
             * @param {?} children
             * @return {?}
             */
            function (children) {
                return children.map((/**
                 * @param {?} child
                 * @return {?}
                 */
                function (child) {
                    return child.controlUpdate.pipe(operators.map((/**
                     * @param {?} update
                     * @return {?}
                     */
                    function (update) { return [update, child.controlKey]; })));
                }));
            })), operators.switchMap((/**
             * @param {?} children
             * @return {?}
             */
            function (children) { return rxjs.merge.apply(void 0, __spread(children)); })))
                .subscribe((/**
             * @param {?} __0
             * @return {?}
             */
            function (_a) {
                var _b = __read(_a, 2), update = _b[0], key = _b[1];
                return _this.emitUpdate(update, key);
            }));
            rxjs.combineLatest(children$, this.formSummary$).subscribe((/**
             * @param {?} __0
             * @return {?}
             */
            function (_a) {
                var _b = __read(_a, 2), children = _b[0], summary = _b[1];
                return _this.updateChildren(children, summary);
            }));
        };
        /**
         * @return {?}
         */
        AbstractFormDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.formSummary$.complete();
        };
        /**
         * @param {?} children
         * @param {?} summary
         * @return {?}
         */
        AbstractFormDirective.prototype.updateChildren = /**
         * @param {?} children
         * @param {?} summary
         * @return {?}
         */
        function (children, summary) {
            if (!children.length) {
                return;
            }
            children.forEach((/**
             * @param {?} control
             * @return {?}
             */
            function (control) {
                control.updateSummary(summary.controls[control.controlKey]);
            }));
        };
        AbstractFormDirective.propDecorators = {
            setFormSummary: [{ type: core.Input, args: ['formSummary',] }],
            formUpdate: [{ type: core.Output }]
        };
        return AbstractFormDirective;
    }(ControlChildren));
    if (false) {
        /** @type {?} */
        AbstractFormDirective.prototype.formUpdate;
        /** @type {?} */
        AbstractFormDirective.prototype.formSummary$;
        /**
         * @abstract
         * @param {?} update
         * @param {?} key
         * @return {?}
         */
        AbstractFormDirective.prototype.emitUpdate = function (update, key) { };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormGroupDirective = /** @class */ (function (_super) {
        __extends(FormGroupDirective, _super);
        function FormGroupDirective() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @param {?} update
         * @param {?} key
         * @return {?}
         */
        FormGroupDirective.prototype.emitUpdate = /**
         * @param {?} update
         * @param {?} key
         * @return {?}
         */
        function (update, key) {
            var _a;
            this.formUpdate.next({ controls: (_a = {}, _a[key] = update, _a) });
        };
        FormGroupDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[ngrxFormGroup]',
                    },] }
        ];
        return FormGroupDirective;
    }(AbstractFormDirective));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormArrayDirective = /** @class */ (function (_super) {
        __extends(FormArrayDirective, _super);
        function FormArrayDirective() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @param {?} update
         * @param {?} key
         * @return {?}
         */
        FormArrayDirective.prototype.emitUpdate = /**
         * @param {?} update
         * @param {?} key
         * @return {?}
         */
        function (update, key) {
            /** @type {?} */
            var index = parseInt(key.toString(), 10);
            /** @type {?} */
            var controls = new Array(index + 1);
            controls[index] = update;
            this.formUpdate.next({ controls: controls });
        };
        FormArrayDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[ngrxFormArray]',
                    },] }
        ];
        return FormArrayDirective;
    }(AbstractFormDirective));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ɵ0 = defaultConfig;
    /**
     * This module represents the entry point of ngrx-clean-forms.
     * It provides all necessary directives for the usage inside templates.
     *
     * The `.withConfig()` method can be used to pass a config to the module.
     *
     * - [npm](https://www.npmjs.com/package/ngrx-clean-forms)
     * - [documentation](https://github.com/NiklasPor/ngrx-clean-forms)
     */
    var NgrxCleanFormsModule = /** @class */ (function () {
        function NgrxCleanFormsModule() {
        }
        /**
         * Creates a new module with the given config. Missing values will be set with default values.
         *
         * @param config A partial `FormsConfig` object, supplying config paramters.
         *
         * @example
         * NgrxCleanFormsModule.withConfig({
         *   throttleTime: 15,
         * }),
         *
         */
        /**
         * Creates a new module with the given config. Missing values will be set with default values.
         *
         * \@example
         * NgrxCleanFormsModule.withConfig({
         *   throttleTime: 15,
         * }),
         *
         * @param {?} config A partial `FormsConfig` object, supplying config paramters.
         *
         * @return {?}
         */
        NgrxCleanFormsModule.withConfig = /**
         * Creates a new module with the given config. Missing values will be set with default values.
         *
         * \@example
         * NgrxCleanFormsModule.withConfig({
         *   throttleTime: 15,
         * }),
         *
         * @param {?} config A partial `FormsConfig` object, supplying config paramters.
         *
         * @return {?}
         */
        function (config) {
            return {
                ngModule: NgrxCleanFormsModule,
                providers: [
                    {
                        provide: CONFIG_TOKEN,
                        useValue: (/** @type {?} */ (__assign({}, defaultConfig, config))),
                    },
                ],
            };
        };
        NgrxCleanFormsModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: __spread([FormGroupDirective, FormArrayDirective], controlDirectives),
                        imports: [common.CommonModule],
                        exports: __spread([FormGroupDirective, FormArrayDirective], controlDirectives),
                        providers: [
                            {
                                provide: CONFIG_TOKEN,
                                useValue: ɵ0,
                            },
                        ],
                    },] }
        ];
        return NgrxCleanFormsModule;
    }());

    exports.NgrxCleanFormsModule = NgrxCleanFormsModule;
    exports.getFormArraySummary = getFormArraySummary;
    exports.getFormControlSummary = getFormControlSummary;
    exports.getFormGroupSummary = getFormGroupSummary;
    exports.initFormArray = initFormArray;
    exports.initFormControl = initFormControl;
    exports.initFormGroup = initFormGroup;
    exports.mapFormGroupControlStates = mapFormGroupControlStates;
    exports.mapFormGroupControlSummaries = mapFormGroupControlSummaries;
    exports.mapFormGroupControlUpdates = mapFormGroupControlUpdates;
    exports.reduceFormArray = reduceFormArray;
    exports.reduceFormControl = reduceFormControl;
    exports.reduceFormGroup = reduceFormGroup;
    exports.resetFormArray = resetFormArray;
    exports.resetFormControl = resetFormControl;
    exports.resetFormGroup = resetFormGroup;
    exports.validatorOf = validatorOf;
    exports.ɵa = mapFormControls;
    exports.ɵb = FormGroupDirective;
    exports.ɵc = AbstractFormDirective;
    exports.ɵd = ControlChildren;
    exports.ɵe = TextInputControlDirective;
    exports.ɵf = CONTROL_DIRECTIVE_SELECTOR;
    exports.ɵg = AbstractControlDirective;
    exports.ɵh = CONFIG_TOKEN;
    exports.ɵi = defaultConfig;
    exports.ɵj = CheckboxInputControlDirective;
    exports.ɵk = NumberInputControlDirective;
    exports.ɵl = RadioInputControlDirective;
    exports.ɵm = RangeInputControlDirective;
    exports.ɵn = SelectInputControlDirective;
    exports.ɵo = ValueAccessorConnectorDirective;
    exports.ɵp = FormArrayDirective;
    exports.ɵq = controlDirectives;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngrx-clean-forms.umd.js.map
