import { ElementRef, Renderer2 } from '@angular/core';
import { AbstractControlDirective } from './abstract-control.directive';
import { FormsConfig } from '../../types';
export declare class TextInputControlDirective extends AbstractControlDirective<string> {
    constructor(ref: ElementRef, r2: Renderer2, config: FormsConfig);
    onInput($event: Event): void;
    onBlur(): void;
    setValue(value: string): void;
    setDisabled(disabled: boolean): void;
}
